import cv2
import sqlite3

cam = cv2.VideoCapture(1)
detector = cv2.CascadeClassifier('haarcascade_frontalface_default.xml')

#intert or update name in Database
def insertOrUpdate(Id,Name,Gender,Excluded):
    conn = sqlite3.connect("FaceBase.db")
    cmd = "SELECT * FROM People WHERE ID="+str(Id)
    cursor = conn.execute(cmd)
    #check is there are entries in the DB
    isRecordExist = 0
    for row in cursor:
        isRecordExist = 1
    if (isRecordExist == 1):
        cmd="UPDATE people SET Name=' "+str(Name)+" ' WHERE ID="+str(Id)
    else:
        cmd = "INSERT INTO People (ID,Name,Gender,Excluded) VALUES ("+Id+",' "+str(Name)+"','"+str(Gender)+"', '" +str(Excluded)+ "')"
    conn.execute(cmd)
    conn.commit()
    conn.close()

Id = raw_input("Enter your id: ")
Name = raw_input("Enter your name: ")
Gender = raw_input("Are you Male or Female? ")
if (Gender == 'Male' or Gender == 'male' or Gender == 'M' or Gender == 'm' ):
    Gender = 'Male'
elif (Gender == "Female" or Gender == "female" or Gender == 'F' or Gender == 'f' ):
    Gender = "Female"
else:
    Gender = "Error"
Excluded = raw_input("Do you wish to be Self-Excluded from Gambling? ")
if (Excluded == "Yes" or Excluded == "Y" or Excluded == "y" or Excluded == "YES"):
    Excluded = True
elif (Excluded == "No" or Excluded == "N" or Excluded == "n" or Excluded == "NO"):
    Excluded = False

insertOrUpdate(Id,Name,Gender,Excluded)

sampleNum = 0

while True:
    ret, img = cam.read()
    gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
    faces = detector.detectMultiScale(gray, 1.3, 5)
    for (x,y,w,h) in faces:
        sampleNum += 1

        cv2.imwrite("dataSet/User." + Id + "."+str(sampleNum)+".jpg",  gray[y:y+h,x:x+w])

        cv2.rectangle(img, (x-50,y-50), (x+w+50, y+h+50), (0,255,0), 2)
        # roi_gray = gray[y:y+h, x:x+w]
        # roi_color = img[y:y+h, x:x+w]
        
    cv2.imshow('img', img)
    cv2.waitKey(100);
    if(sampleNum>20):
        cam.release()
        cv2.destroyAllWindows()
        break;
