#this script captures faces and then creates a dataset to dataSet/ folder
#Three steps to recognise face
    #1: create dataset -> dataset creator
    #2: train the recogniser -> trainner    <- THIS SCRIPT DOES THIS 1st STEP
    #3: face detector -> detector

import os
import cv2
import numpy as np
from PIL import Image

recognizer = cv2.face.createLBPHFaceRecognizer()
path = 'dataSet'

def getImagesWithID(path):
    #create a array of image paths
    imagePaths = [os.path.join(path,f) for f in os.listdir(path)]
    faces = []
    IDs= []
    for imagePath in imagePaths:
        #this is a PIL (pillow) image
        faceImg = Image.open(imagePath).convert('L');
        #numpy
        faceNp = np.array(faceImg, 'uint8')
        #split path to get ID number
        ID = int(os.path.split(imagePath)[-1].split('.')[1])
        #add image and ID to arrays
        faces.append(faceNp)
        IDs.append(ID)
        cv2.imshow("training", faceNp)
        cv2.waitKey(10)
    return IDs, faces

Ids, faces = getImagesWithID(path)
recognizer.train(faces, np.array(Ids))
recognizer.save('recognizer/trainingData.yml')
cv2.destroyAllWindows()
